<?php

  if($source["reference"]){
    $groupes = array();
    foreach($source["reference"]["groupes"] as $groupe){
      $groupes[] = array(
        "nom" => $groupe["nom"],
        "url" => $source["reference"] ? $source["reference"]["from"] : $source["url"]
      );
    }
  }
  else{
    $groupes = $data->get_editor_groupes($source["reference"] ? $source["reference"]["groupes"] : $source["groupes"]);
    foreach($groupes as $k => $groupe) $groupes[$k]["url"] = $this->url("sources/groupe/view", array("id" => $groupe["id"]));
  }

?>
<header>

  <?php if($groupes) : ?>
  <ul class="authors">
    <?php foreach($groupes as $groupe) : ?>
    <li><a class="auteur" href="<?php echo $groupe["url"] ?>"><?php echo $groupe["nom"] ?></a></li>
    <?php endforeach; ?>
  </ul>
  <?php endif; ?>
  <?php if(!isset($display_name) || $display_name) : ?>
  <?php

    $source_image_url = false;
    if($source["reference"]){
      if(
           isset($source["reference"]["image"])
        && $source["reference"]["image"]
      ){
        $source_image_url = $source["reference"]["image"];
      }
    }
    else{
      if
      (    isset($source["image_uri"])
        && $source["image_uri"]
        && file_exists($source["image_uri"])
      ){
        $source_image_url = $source["image_uri"];
      }
    }
    if($source_image_url){
      $source_thumb = false;
      if($data->mw_thumbs_activated()){
        $source_thumb = $data->img_thumb(
          $source_image_url,
          100,
          100,
          $this->path("content")."thumbs",
          array(255, 255, 255),
          true
        );
      }
    }

  ?>
  <?php if($source_image_url) : ?>
  <p class="logo_source">
    <a href="<?php echo $source["reference"] ? $source["reference"]["from"] : $source["url"] ?>">
      <?php if($source_thumb) : ?>
      <img src="<?php echo $this->path("content")."thumbs/".$source_thumb["thumb_file"] ?>"
           width="<?php echo $source_thumb["thumb_width"] ?>"
           height="<?php echo $source_thumb["thumb_height"] ?>"
           alt="" />
      <?php else : ?>
      <img src="<?php echo $source_image_url ?>" style="width: 100px; height: auto" alt="" />
      <?php endif; ?>
    </a>
  </p>
  <?php endif; ?>
  <h1<?php if($source_image_url): ?> class="with_image"<?php endif; ?>>
    <?php if($source["reference"]) : ?>
    <span>r&eacute;f&eacute;rence &raquo; <a href="<?php echo $source["reference"]["from"] ?>"><strong><?php echo $source["reference"]["titre"] ?></strong></a></span>
    <?php else : ?>
    <a href="<?php echo $source["url"] ?>"><?php echo $source["titre"] ?></a>
    <?php endif; ?>
    <?php if($source["derivations"]) : ?>
    <br />
    <span class="small">
      d&eacute;rive de &raquo;
      <?php $n = 0; foreach($source["derivations"] as $derivation) : ?>
      <?php echo $n ? ", " : "" ?><a href="<?php echo $derivation["from"] ?>"><strong><?php echo $derivation["titre"] ?></strong></a>
      <?php $n++; endforeach; ?>
    </span>
    <?php endif; ?>
  </h1>
  <?php endif; ?>

  <br class="clear" />

</header>
